require 'racc/parser'

type.module_eval <<'..end xmldtd.ry modeval..id6b4a0cbd1e', 'xmldtd.ry', 216
#
# xmldtd.rb : generated by racc
#

require 'xmlscan'
require 'strscan'


..end xmldtd.ry modeval..id6b4a0cbd1e

class XMLDTDScanner < ::Racc::Parser

module_eval <<'..end xmldtd.ry modeval..ideded1886a8', 'xmldtd.ry', 225

  Keywords = {}
  KeywordsWithSpace = {}

  [ 'ELEMENT', 'ATTLIST',
    'INCLUDE', 'IGNORE', '#PCDATA', 'ENTITY', 'NOTATION',
  ].each { |i| Keywords[i] = i.tr('#', 'H').intern }

  [ 'EMPTY', 'ANY', 'CDATA', 'ID', 'IDREF', 'IDREFS', 'ENTITIES',
    'NMTOKEN', 'NMTOKENS', '#REQUIRED', '#IMPLIED', '#FIXED',
    'SYSTEM', 'PUBLIC', 'NDATA',
    'INCLUDE', 'IGNORE', '#PCDATA', 'ENTITY', 'NOTATION'
  ].each { |i| KeywordsWithSpace[i] = ('_' + i.tr('#', 'H')).intern }



  class DTDTokenizer

    # \s*<?...?> => PI
    # \s+--.*?-- => Comment following space
    # --.*?--    => Comment
    # \s*<![     => '<!['
    # \s*[       => '['
    # \s*]]>     => ']]>'
    # \s*<!      => '<!'
    # \s+\w+     => Name following space
    # \w+        => Name
    # \s*>       => '>'
    # \s+(       => ' ('
    # (          => '('
    # \s*|       => '|'
    # \s*,       => ','
    # \s*)       => ')'
    # \s+\*      => ' *'
    # \*         => '*'
    # \s+\?      => ' ?'
    # \?         => '?'
    # \s+\+      => ' +'
    # \+         => '+'
    # \s+".*?"   => String following space
    # ".*?"      => String
    # \s+'.*?'   => String following space
    # '.*?'      => String
    # \s*%\w+;   => PEReference
    # \s+%       => ' %'

    PortWrapper = XMLScanner::XMLSource::PortWrapper

    def initialize(src)
      @src = PortWrapper.new(src)
      @ignore = false
      @buf = []
      nextline
    end

    def lineno
      @src.lineno
    end

    def path
      @src.path
    end


    attr_reader :ignore

    def ignore=(f)
      @ignore = (f != nil and f != false)
    end


    def pushback(str)
      @buf.push @scan if @scan
      str = ' ' + str
      @scan = StringScanner.new(str << ' ')
      self
    end


    private

    def nextline
      @scan = (@buf.shift or ((s = @src.gets) and StringScanner.new(s)))
    end


    def scan_until(re, t)
      ret = @scan.scan_until(re)
      unless ret then
        ret = @scan.rest
        while true
          raise ParseError, "unterminated #{t} meets EOF" unless nextline
          s = @scan.scan_until(re)
          break if s
          ret << @scan.rest
        end
        ret << s
      end
      ret
    end


    def skip_until(re)
      ret = @scan.skip_until(re)
      unless ret then
        ret = @scan.restsize
        while true
          return nil unless nextline
          n = @scan.skip_until(re)
          break if n
          ret += @scan.restsize
        end
        ret += n
      end
      ret
    end


    def skip_space
      begin
        n = @scan.skip(/\s+/)
        break unless n
      end while @scan.empty? and nextline
      n
    end


    def scan_pi
      unless @scan.scan(/([^\s\?\>]+)(?:\s+|(?=\?>))/) then
        raise ParseError, "parse error at `<?'"
      end
      name = @scan[1]
      s = scan_until(/\?>/, 'PI')
      s.chop!.chop!
      if name == 'xml' then
        [ :TextDecl, s ]
      else
        [ :PI, [ name, s ] ]
      end
    end


    def on_name(s, space)
      if space then
        [ (KeywordsWithSpace[s] or :_Name), s ]
      else
        [ (Keywords[s] or :Name), s ]
      end
    end

    def on_pe_ref(s)
      [ :PEReference, s ]
    end

    def on_delimiter(c)
      skip_space
      [ c, c ]
    end


    public

    Delim = '\\s!"%&\'\\(\\)\\*\\+,\\/<=>\\?\\[\\]\\|'

    def next_token
      nextline while @scan and @scan.empty?
      space = skip_space if @scan
      if not @scan then
        [ false, :eof ]
      elsif @ignore then
        if @scan.skip_until(/<!\[|\]\]>/) then
          s = @scan[0]
          [ s, s ]
        else
          [ false, :eof ]
        end
      elsif s = @scan.scan(/[^-#{Delim}][^#{Delim}]*/o) then
        on_name s, space
      elsif s = @scan.scan(/<\?|<!\[?|\]\]>|--|[\[>()|,*?+%'"]/) then
        if s == '--' then
          s = scan_until(/--/, 'comment')
          s.chop!.chop!
          if space then
            [ :_Comment, s ]
          else
            [ :Comment, s ]
          end
        elsif s == '<?' then
          scan_pi
        elsif s == '"' or s == "'" then
          s = scan_until(/#{s}/, 'string')
          s.chop!
          if space then
            [ :_String, s ]
          else
            [ :String, s ]
          end
        elsif s == '%' then
          if @scan.skip(/([^-#{Delim}][^#{Delim}]*);/o) then
            on_pe_ref @scan[1]
          elsif space then
            [ ' %', s ]
          else
            [ s, s ]
          end
        elsif (s == '(' or s == '?' or s == '*' or s == '+') and space then
          [ ' ' + s, s ]
        else
          [ s, s ]
        end
      else
        on_delimiter @scan.getch
      end
    end

  end





  def initialize(src = nil)
    #@yydebug = true
    feed src
  end

  def feed(src)
    @src = (src and DTDTokenizer.new(src))
  end

  def parse(src = nil)
    feed src if src
    do_parse if @src
    self
  end

  def lineno
    if @src then
      @src.lineno
    else
      0
    end
  end

  def path
    if @src then
      @src.path
    else
      '-'
    end
  end

  #def do_parse
  #  while true
  #    t,v = next_token
  #    break unless t
  #  end
  #end


  def next_token
    t, v = @src.next_token
    #p [ t, v ]
    [ t, v ]
  end
  private :next_token


  private

  def on_general_entity(name, definition)
  end

  def on_parameter_entity(name, definition)
  end


..end xmldtd.ry modeval..ideded1886a8

##### racc 1.3.11 generates ###

racc_reduce_table = [
 0, 0, :racc_error,
 0, 49, :_reduce_none,
 2, 49, :_reduce_none,
 2, 49, :_reduce_none,
 2, 49, :_reduce_4,
 1, 49, :_reduce_none,
 0, 50, :_reduce_none,
 2, 50, :_reduce_7,
 2, 50, :_reduce_8,
 2, 50, :_reduce_none,
 3, 51, :_reduce_none,
 2, 51, :_reduce_none,
 4, 53, :_reduce_none,
 0, 57, :_reduce_13,
 5, 53, :_reduce_14,
 1, 54, :_reduce_none,
 1, 54, :_reduce_none,
 1, 55, :_reduce_none,
 1, 55, :_reduce_none,
 0, 56, :_reduce_none,
 3, 56, :_reduce_none,
 1, 52, :_reduce_none,
 1, 52, :_reduce_none,
 1, 52, :_reduce_none,
 1, 52, :_reduce_none,
 1, 52, :_reduce_25,
 3, 58, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 4, 63, :_reduce_none,
 0, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 64, :_reduce_none,
 1, 64, :_reduce_none,
 2, 68, :_reduce_none,
 4, 68, :_reduce_none,
 1, 66, :_reduce_none,
 3, 66, :_reduce_none,
 3, 67, :_reduce_none,
 3, 67, :_reduce_none,
 3, 59, :_reduce_none,
 0, 70, :_reduce_none,
 4, 70, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 1, 71, :_reduce_none,
 4, 71, :_reduce_none,
 3, 71, :_reduce_none,
 1, 73, :_reduce_none,
 3, 73, :_reduce_none,
 1, 72, :_reduce_none,
 1, 72, :_reduce_none,
 2, 72, :_reduce_none,
 1, 72, :_reduce_none,
 2, 60, :_reduce_none,
 2, 74, :_reduce_62,
 3, 74, :_reduce_63,
 1, 75, :_reduce_none,
 2, 75, :_reduce_none,
 0, 78, :_reduce_none,
 2, 78, :_reduce_none,
 1, 76, :_reduce_none,
 1, 76, :_reduce_none,
 2, 77, :_reduce_70,
 3, 77, :_reduce_71,
 3, 61, :_reduce_none,
 1, 79, :_reduce_none,
 2, 79, :_reduce_74,
 1, 62, :_reduce_none,
 1, 62, :_reduce_none,
 1, 69, :_reduce_none,
 1, 69, :_reduce_none,
 1, 69, :_reduce_none,
 1, 81, :_reduce_none,
 1, 81, :_reduce_none,
 1, 81, :_reduce_none,
 1, 81, :_reduce_none,
 1, 81, :_reduce_none,
 1, 81, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none,
 1, 80, :_reduce_none ]

racc_reduce_n = 102

racc_shift_n = 148

racc_action_table = [
    85,    35,    87,    42,   145,    92,    47,    50,   146,     5,
   144,     6,    61,    66,   144,   102,    93,    49,    51,    52,
    32,    34,    38,    41,    44,    46,     9,   107,    10,     5,
    84,     6,    37,    40,    43,    91,    48,    95,    85,    35,
    87,    42,    65,    92,    47,    50,    61,    62,    78,   108,
   109,    89,    61,    62,    93,    49,    51,    52,    32,    34,
    38,    41,    44,    46,     9,    83,    10,     5,    84,     6,
    37,    40,    43,    91,    48,    95,    85,    35,    87,    42,
   103,    92,    47,    50,   125,     9,   106,    10,     5,    89,
     6,   127,    93,    49,    51,    52,    32,    34,    38,    41,
    44,    46,     9,    79,    10,     5,    84,     6,    37,    40,
    43,    91,    48,    95,    85,    35,    87,    42,   103,    92,
    47,    50,    59,     3,     4,    -6,     5,    89,     6,    58,
    93,    49,    51,    52,    32,    34,    38,    41,    44,    46,
   133,   134,   135,   136,    84,   102,    37,    40,    43,    91,
    48,    95,    85,    35,    87,    42,   137,    92,    47,    50,
    24,    25,    26,    27,    57,    89,   140,    80,    93,    49,
    51,    52,    32,    34,    38,    41,    44,    46,   110,   111,
   112,   142,    84,    53,    37,    40,    43,    91,    48,    95,
    85,    35,    87,    42,    31,    92,    47,    50,    70,    71,
    72,    81,   100,    89,   nil,   nil,    93,    49,    51,    52,
    32,    34,    38,    41,    44,    46,   110,   111,   112,   nil,
    84,   nil,    37,    40,    43,    91,    48,    95,    85,    35,
    87,    42,   nil,    92,    47,    50,   110,   111,   112,   nil,
   nil,   nil,   nil,   nil,    93,    49,    51,    52,    32,    34,
    38,    41,    44,    46,   nil,   nil,   nil,   nil,    84,   nil,
    37,    40,    43,    91,    48,    95,    85,    35,    87,    42,
   nil,    92,    47,    50,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    93,    49,    51,    52,    32,    34,    38,    41,
    44,    46,   nil,   nil,   nil,   nil,    84,   nil,    37,    40,
    43,    91,    48,    95,    35,   nil,    42,   nil,   nil,    47,
    50,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
    49,    51,    52,    32,    34,    38,    41,    44,    46,   nil,
   nil,   nil,   nil,   nil,   nil,    37,    40,    43,    35,    48,
    42,   nil,   nil,    47,    50,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    49,    51,    52,    32,    34,    38,
    41,    44,    46,   nil,   nil,   nil,   nil,   nil,   nil,    37,
    40,    43,    35,    48,    42,   nil,   nil,    47,    50,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    49,    51,
    52,    32,    34,    38,    41,    44,    46,   nil,   nil,   nil,
   nil,   nil,   nil,    37,    40,    43,    35,    48,    42,   nil,
   nil,    47,    50,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    49,    51,    52,    32,    34,    38,    41,    44,
    46,   nil,   nil,   nil,   nil,   nil,   nil,    37,    40,    43,
    35,    48,    42,   nil,   nil,    47,    50,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,    49,    51,    52,    32,
    34,    38,    41,    44,    46,   nil,   nil,   nil,   nil,   nil,
    36,    37,    40,    43,    35,    48,    42,   nil,   nil,    47,
    50,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
    49,    51,    52,    32,    34,    38,    41,    44,    46,   nil,
   nil,   nil,   nil,   nil,   nil,    37,    40,    43,    35,    48,
    42,    18,    20,    47,    50,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,    21,    49,    51,    52,    32,    34,    38,
    41,    44,    46,   nil,   nil,   122,   nil,    14,   nil,    37,
    40,    43,    19,    48,   121,   123,   124,   114,   115,   117,
   118,   119,   120 ]

racc_action_check = [
   144,   144,   144,   144,   138,   144,   144,   144,   143,    57,
   138,    57,    54,    54,   143,   102,   144,   144,   144,   144,
   144,   144,   144,   144,   144,   144,    11,    94,    11,    11,
   144,    11,   144,   144,   144,   144,   144,   144,    72,    72,
    72,    72,    39,    72,    72,    72,    39,    39,    60,    96,
    97,    72,    60,    60,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    12,    66,    12,    12,    72,    12,
    72,    72,    72,    72,    72,    72,    89,    89,    89,    89,
    83,    89,    89,    89,   101,     1,    90,     1,     1,    89,
     1,   105,    89,    89,    89,    89,    89,    89,    89,    89,
    89,    89,    13,    61,    13,    13,    89,    13,    89,    89,
    89,    89,    89,    89,   107,   107,   107,   107,    80,   107,
   107,   107,    31,     0,     0,     0,     0,   107,     0,    30,
   107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
   116,   116,   116,   116,   107,    75,   107,   107,   107,   107,
   107,   107,   108,   108,   108,   108,   120,   108,   108,   108,
     6,     6,     6,     6,    29,   108,   126,    62,   108,   108,
   108,   108,   108,   108,   108,   108,   108,   108,   127,   127,
   127,   135,   108,    17,   108,   108,   108,   108,   108,   108,
   109,   109,   109,   109,     7,   109,   109,   109,    55,    55,
    55,    64,    74,   109,   nil,   nil,   109,   109,   109,   109,
   109,   109,   109,   109,   109,   109,   106,   106,   106,   nil,
   109,   nil,   109,   109,   109,   109,   109,   109,   122,   122,
   122,   122,   nil,   122,   122,   122,    98,    98,    98,   nil,
   nil,   nil,   nil,   nil,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   nil,   nil,   nil,   nil,   122,   nil,
   122,   122,   122,   122,   122,   122,   137,   137,   137,   137,
   nil,   137,   137,   137,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   137,   nil,   nil,   nil,   nil,   137,   nil,   137,   137,
   137,   137,   137,   137,    21,   nil,    21,   nil,   nil,    21,
    21,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
    21,    21,    21,    21,    21,    21,    21,    21,    21,   nil,
   nil,   nil,   nil,   nil,   nil,    21,    21,    21,    73,    21,
    73,   nil,   nil,    73,    73,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    73,    73,    73,    73,    73,    73,
    73,    73,    73,   nil,   nil,   nil,   nil,   nil,   nil,    73,
    73,    73,    19,    73,    19,   nil,   nil,    19,    19,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    19,    19,
    19,    19,    19,    19,    19,    19,    19,   nil,   nil,   nil,
   nil,   nil,   nil,    19,    19,    19,    20,    19,    20,   nil,
   nil,    20,    20,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    20,    20,    20,    20,    20,    20,    20,    20,
    20,   nil,   nil,   nil,   nil,   nil,   nil,    20,    20,    20,
    14,    20,    14,   nil,   nil,    14,    14,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,    14,    14,    14,    14,
    14,    14,    14,    14,    14,   nil,   nil,   nil,   nil,   nil,
    14,    14,    14,    14,    81,    14,    81,   nil,   nil,    81,
    81,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
    81,    81,    81,    81,    81,    81,    81,    81,    81,   nil,
   nil,   nil,   nil,   nil,   nil,    81,    81,    81,    36,    81,
    36,     5,     5,    36,    36,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,     5,    36,    36,    36,    36,    36,    36,
    36,    36,    36,   nil,   nil,    99,   nil,     5,   nil,    36,
    36,    36,     5,    36,    99,    99,    99,    99,    99,    99,
    99,    99,    99 ]

racc_action_pointer = [
   121,    83,   nil,   nil,   nil,   497,   150,   194,   nil,   nil,
   nil,    24,    62,   100,   429,   nil,   nil,   177,   nil,   361,
   395,   293,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   156,
   121,   122,   nil,   nil,   nil,   nil,   497,   nil,   nil,     3,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   -31,   182,   nil,     4,   nil,   nil,
     9,    64,   128,   nil,   159,   nil,    26,   nil,   nil,   nil,
   nil,   nil,    28,   327,   193,   138,   nil,   nil,   nil,   nil,
    79,   463,   nil,    41,   nil,   nil,   nil,   nil,   nil,    66,
    67,   nil,   nil,   nil,     3,   nil,    24,    25,   216,   517,
   nil,    75,     8,   nil,   nil,    72,   196,   104,   142,   180,
   nil,   nil,   nil,   nil,   nil,   nil,   104,   nil,   nil,   nil,
   138,   nil,   218,   nil,   nil,   nil,   157,   158,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   142,   nil,   256,   -15,   nil,
   nil,   nil,   nil,   -11,   -10,   nil,   nil,   nil ]

racc_action_default = [
    -1,    -5,    -6,    -6,    -6,  -102,  -102,  -102,    -9,    -7,
    -8,    -3,    -2,    -4,  -102,   -23,   -24,  -102,   -25,  -102,
  -102,  -102,   -21,   -22,   -15,   -16,   -17,   -18,   -11,  -102,
  -102,  -102,   -93,   -76,   -94,   -86,  -102,  -101,   -95,  -102,
   -99,   -96,   -87,  -100,   -97,   -61,   -98,   -88,   -75,   -90,
   -89,   -91,   -92,   -10,  -102,  -102,   -43,  -102,   -13,   148,
  -102,  -102,  -102,   -62,   -66,   -64,  -102,   -73,   -72,   -26,
   -27,   -28,  -102,   -42,  -102,   -19,   -63,   -69,   -68,   -70,
  -102,  -102,   -65,   -74,   -84,   -80,   -79,   -81,   -78,  -102,
  -102,   -85,   -82,   -83,   -34,   -77,   -35,   -38,   -30,  -102,
   -12,  -102,   -19,   -71,   -67,  -102,   -30,  -102,  -102,  -102,
   -31,   -32,   -33,   -36,   -48,   -49,  -102,   -50,   -51,   -52,
  -102,   -45,  -102,   -46,   -47,   -14,  -102,   -30,   -29,   -39,
   -41,   -40,   -44,   -57,   -58,  -102,   -60,  -102,  -102,   -55,
   -20,   -37,   -59,  -102,  -102,   -54,   -53,   -56 ]

racc_goto_table = [
    39,     2,   113,   101,   139,    54,    55,    56,    64,   138,
   128,    90,     1,    69,    11,    12,    13,    15,    16,   139,
    22,    23,    60,    67,   143,    75,   147,    30,   105,    77,
   126,   141,   129,   130,   131,    29,    28,    73,   116,   132,
    17,    45,    63,    76,     7,    82,    68,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    74,    99,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   104 ]

racc_goto_check = [
    14,     3,    17,     8,    21,    14,    14,    14,    29,    25,
    17,    16,     2,    15,     2,     2,     2,    12,    13,    21,
    10,    11,    14,    29,    25,     9,    21,     7,    16,    29,
     8,    17,    20,    20,    20,     6,     5,    22,    23,    24,
     4,    26,    27,    28,     1,    30,    31,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,     3,    14,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,    14 ]

racc_goto_pointer = [
   nil,    44,    12,     1,    35,    30,    29,    21,   -72,   -33,
    15,    16,    12,    13,   -14,   -42,   -61,   -96,   nil,   nil,
   -75,  -118,   -19,   -61,   -77,  -113,    27,     3,   -17,   -31,
   -19,    -8,   nil,   nil ]

racc_goto_default = [
   nil,   nil,   nil,     8,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    88,   nil,   nil,   nil,    94,    96,
    97,    98,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    33,    86 ]

racc_token_table = {
 false => 0,
 Object.new => 1,
 :PI => 2,
 :TextDecl => 3,
 :PEReference => 4,
 "<!" => 5,
 ">" => 6,
 "<![" => 7,
 "[" => 8,
 "]]>" => 9,
 :INCLUDE => 10,
 :_INCLUDE => 11,
 :IGNORE => 12,
 :_IGNORE => 13,
 :Comment => 14,
 :ELEMENT => 15,
 :_EMPTY => 16,
 :_ANY => 17,
 " (" => 18,
 ")" => 19,
 "?" => 20,
 "*" => 21,
 "+" => 22,
 "(" => 23,
 "," => 24,
 "|" => 25,
 :ATTLIST => 26,
 :_CDATA => 27,
 :_ID => 28,
 :_IDREF => 29,
 :_IDREFS => 30,
 :_ENTITY => 31,
 :_ENTITIES => 32,
 :_NMTOKEN => 33,
 :_NMTOKENS => 34,
 :_NOTATION => 35,
 :_HREQUIRED => 36,
 :_HIMPLIED => 37,
 :_FIXED => 38,
 :_String => 39,
 :ENTITY => 40,
 " %" => 41,
 :_NDATA => 42,
 :_SYSTEM => 43,
 :_PUBLIC => 44,
 :NOTATION => 45,
 :_Name => 46,
 :Name => 47 }

racc_use_result_var = false

racc_nt_base = 48

Racc_arg = [
 racc_action_table,
 racc_action_check,
 racc_action_default,
 racc_action_pointer,
 racc_goto_table,
 racc_goto_check,
 racc_goto_default,
 racc_goto_pointer,
 racc_nt_base,
 racc_reduce_table,
 racc_token_table,
 racc_shift_n,
 racc_reduce_n,
 racc_use_result_var ]

Racc_token_to_s_table = [
'$end',
'error',
'PI',
'TextDecl',
'PEReference',
'"<!"',
'">"',
'"<!["',
'"["',
'"]]>"',
'INCLUDE',
'_INCLUDE',
'IGNORE',
'_IGNORE',
'Comment',
'ELEMENT',
'_EMPTY',
'_ANY',
'" ("',
'")"',
'"?"',
'"*"',
'"+"',
'"("',
'","',
'"|"',
'ATTLIST',
'_CDATA',
'_ID',
'_IDREF',
'_IDREFS',
'_ENTITY',
'_ENTITIES',
'_NMTOKEN',
'_NMTOKENS',
'_NOTATION',
'_HREQUIRED',
'_HIMPLIED',
'_FIXED',
'_String',
'ENTITY',
'" %"',
'_NDATA',
'_SYSTEM',
'_PUBLIC',
'NOTATION',
'_Name',
'Name',
'$start',
'extSubset',
'extSubsetDecls',
'extSubsetDecl',
'markupDecl',
'conditionalSect',
'include',
'ignore',
'ignoreSectContents',
'@1',
'elementDecl',
'attlistDecl',
'entityDecl',
'notationDecl',
'_name',
'contentspec',
'childrenContent',
'repmark',
'seq',
'choice',
'cp',
'name',
'attDef',
'attType',
'defaultDecl',
'namelist',
'entity',
'entityDef',
'peDef',
'externalID',
'ndataDecl',
'notationID',
'_keywords',
'keywords']

Racc_debug_parser = true

##### racc system variables end #####

 # reduce 0 omitted

 # reduce 1 omitted

 # reduce 2 omitted

 # reduce 3 omitted

module_eval <<'.,.,', 'xmldtd.ry', 84
  def _reduce_4( val, _values)
 p val[0]
  end
.,.,

 # reduce 5 omitted

 # reduce 6 omitted

module_eval <<'.,.,', 'xmldtd.ry', 89
  def _reduce_7( val, _values)
 p [ :PI, val[1] ]
  end
.,.,

module_eval <<'.,.,', 'xmldtd.ry', 91
  def _reduce_8( val, _values)
 p [ :PI, val[1] ]
  end
.,.,

 # reduce 9 omitted

 # reduce 10 omitted

 # reduce 11 omitted

 # reduce 12 omitted

module_eval <<'.,.,', 'xmldtd.ry', 100
  def _reduce_13( val, _values)
 @src.ignore = true
  end
.,.,

module_eval <<'.,.,', 'xmldtd.ry', 102
  def _reduce_14( val, _values)
 @src.ignore = false
  end
.,.,

 # reduce 15 omitted

 # reduce 16 omitted

 # reduce 17 omitted

 # reduce 18 omitted

 # reduce 19 omitted

 # reduce 20 omitted

 # reduce 21 omitted

 # reduce 22 omitted

 # reduce 23 omitted

 # reduce 24 omitted

module_eval <<'.,.,', 'xmldtd.ry', 116
  def _reduce_25( val, _values)
 p [ :Comment, val[0] ]
  end
.,.,

 # reduce 26 omitted

 # reduce 27 omitted

 # reduce 28 omitted

 # reduce 29 omitted

 # reduce 30 omitted

 # reduce 31 omitted

 # reduce 32 omitted

 # reduce 33 omitted

 # reduce 34 omitted

 # reduce 35 omitted

 # reduce 36 omitted

 # reduce 37 omitted

 # reduce 38 omitted

 # reduce 39 omitted

 # reduce 40 omitted

 # reduce 41 omitted

 # reduce 42 omitted

 # reduce 43 omitted

 # reduce 44 omitted

 # reduce 45 omitted

 # reduce 46 omitted

 # reduce 47 omitted

 # reduce 48 omitted

 # reduce 49 omitted

 # reduce 50 omitted

 # reduce 51 omitted

 # reduce 52 omitted

 # reduce 53 omitted

 # reduce 54 omitted

 # reduce 55 omitted

 # reduce 56 omitted

 # reduce 57 omitted

 # reduce 58 omitted

 # reduce 59 omitted

 # reduce 60 omitted

 # reduce 61 omitted

module_eval <<'.,.,', 'xmldtd.ry', 171
  def _reduce_62( val, _values)
 on_general_entity(val[0], val[1])
  end
.,.,

module_eval <<'.,.,', 'xmldtd.ry', 173
  def _reduce_63( val, _values)
 on_parameter_entity(val[1], val[2])
  end
.,.,

 # reduce 64 omitted

 # reduce 65 omitted

 # reduce 66 omitted

 # reduce 67 omitted

 # reduce 68 omitted

 # reduce 69 omitted

module_eval <<'.,.,', 'xmldtd.ry', 186
  def _reduce_70( val, _values)
 [ nil, val[1] ]
  end
.,.,

module_eval <<'.,.,', 'xmldtd.ry', 188
  def _reduce_71( val, _values)
 [ val[1], val[2] ]
  end
.,.,

 # reduce 72 omitted

 # reduce 73 omitted

module_eval <<'.,.,', 'xmldtd.ry', 195
  def _reduce_74( val, _values)
 [ val[1], nil ]
  end
.,.,

 # reduce 75 omitted

 # reduce 76 omitted

 # reduce 77 omitted

 # reduce 78 omitted

 # reduce 79 omitted

 # reduce 80 omitted

 # reduce 81 omitted

 # reduce 82 omitted

 # reduce 83 omitted

 # reduce 84 omitted

 # reduce 85 omitted

 # reduce 86 omitted

 # reduce 87 omitted

 # reduce 88 omitted

 # reduce 89 omitted

 # reduce 90 omitted

 # reduce 91 omitted

 # reduce 92 omitted

 # reduce 93 omitted

 # reduce 94 omitted

 # reduce 95 omitted

 # reduce 96 omitted

 # reduce 97 omitted

 # reduce 98 omitted

 # reduce 99 omitted

 # reduce 100 omitted

 # reduce 101 omitted

 def _reduce_none( val, _values)
  val[0]
 end

end   # class XMLDTDScanner

type.module_eval <<'..end xmldtd.ry modeval..id17458ad1ae', 'xmldtd.ry', 503

s = XMLDTDScanner.new
STDOUT.sync = STDERR.sync = true

src = ARGF
s.parse src
..end xmldtd.ry modeval..id17458ad1ae
